'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _universalEnv = require('universal-env');

var _raxTouchable = require('rax-touchable');

var _raxTouchable2 = _interopRequireDefault(_raxTouchable);

var _raxText = require('rax-text');

var _raxText2 = _interopRequireDefault(_raxText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Picker = function (_Component) {
  _inherits(Picker, _Component);

  function Picker(props) {
    _classCallCheck(this, Picker);

    var _this = _possibleConstructorReturn(this, (Picker.__proto__ || Object.getPrototypeOf(Picker)).call(this, props));

    _initialiseProps.call(_this);

    var pickerData = _this.getPickerData();
    _this.state = {
      selectedLabel: pickerData.selectedLabel
    };
    return _this;
  }

  _createClass(Picker, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var style = _extends({}, styles.initial, this.props.style);
      var textStyle = {
        color: style.color,
        fontSize: style.fontSize,
        fontStyle: style.fontStyle,
        fontWeight: style.fontWeight,
        textAlign: style.textAlign,
        textDecoration: style.textDecoration,
        textOverflow: style.textOverflow,
        lineHeight: style.lineHeight
      };

      if (_universalEnv.isWeex) {
        return (0, _rax.createElement)(
          _raxTouchable2.default,
          _extends({}, this.props, { onPress: this.handlePress, style: style }),
          (0, _rax.createElement)(
            _raxText2.default,
            { style: textStyle },
            this.state.selectedLabel
          )
        );
      } else {
        var pickerData = this.getPickerData();
        return (0, _rax.createElement)(
          'select',
          { style: style, onChange: function onChange(e) {
              _this2.handlePress(e.target.options.selectedIndex);
            } },
          pickerData.items.map(function (item, index) {
            if (index == pickerData.selectIndex) {
              return (0, _rax.createElement)(
                'option',
                { selected: 'selected', value: item.value },
                item.label
              );
            } else {
              return (0, _rax.createElement)(
                'option',
                { value: item.value },
                item.label
              );
            }
          })
        );
      }
    }
  }]);

  return Picker;
}(_rax.Component);

Picker.propTypes = {};

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.getPickerData = function () {
    var _props = _this4.props,
        children = _props.children,
        selectedValue = _props.selectedValue;

    var pickerItems = [],
        pickerLabelList = [],
        items = [],
        selectIndex = 0,
        selectedLabel = void 0;

    if (children.length) {
      pickerItems = children;
    } else {
      pickerItems = [children];
    }

    pickerLabelList = pickerItems.map(function (item, index) {
      var _item$props = item.props,
          value = _item$props.value,
          label = _item$props.label,
          color = _item$props.color;

      items.push({
        value: value,
        label: label || value
      });
      if (value == selectedValue) {
        selectIndex = index;
        selectedLabel = label;
      }
      return label;
    });

    return {
      selectIndex: selectIndex,
      selectedLabel: selectedLabel,
      pickerLabelList: pickerLabelList,
      items: items
    };
  };

  this.getPickerDataByIndex = function (index, pickerData) {
    return {
      value: pickerData.items[index].value,
      label: pickerData.items[index].label
    };
  };

  this.handlePress = function (webIndex) {
    var _props2 = _this4.props,
        onValueChange = _props2.onValueChange,
        selectedValue = _props2.selectedValue;


    if (_universalEnv.isWeex) {
      var picker = require('@weex-module/picker');
      var pickerData = _this4.getPickerData();
      picker.pick({
        index: pickerData.selectIndex,
        items: pickerData.pickerLabelList
      }, function (event) {
        if (event.result === 'success') {
          var _getPickerDataByIndex = _this4.getPickerDataByIndex(event.data, pickerData),
              value = _getPickerDataByIndex.value,
              label = _getPickerDataByIndex.label;

          onValueChange && onValueChange(value, pickerData.items);
          _this4.setState({
            selectedLabel: label
          });
        }
      });
    } else {
      var _pickerData = _this4.getPickerData();

      var _getPickerDataByIndex2 = _this4.getPickerDataByIndex(webIndex, _pickerData),
          value = _getPickerDataByIndex2.value;

      onValueChange && onValueChange(value, _pickerData.items);
    }
  };
};

var Item = function (_Component2) {
  _inherits(Item, _Component2);

  function Item() {
    _classCallCheck(this, Item);

    return _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).apply(this, arguments));
  }

  _createClass(Item, [{
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Item;
}(_rax.Component);

;

Picker.Item = Item;

var styles = {
  initial: {
    display: 'flex',
    justifyContent: 'center',
    flexDirection: 'row'
  }
};

exports.default = Picker;
module.exports = exports['default'];